*! v 1.0.1 PR 30mar2007
*! Based on WvP class.ado, 9/4/96
program define categ, sortpreserve
version 8
syntax varlist(max=1) [if] [in] [, All CEntile(numlist ascending >0 <100) ///
  CUtpoint(numlist ascending) GENerate(string) MIssing Nclass(int 4) REPLACE ]
if `nclass'<=1 {
	di as err "Number of classes should be >=2"
	exit 198
}
if "`all'"!="" & "`centile'`cutpoint'"=="" {
	di as err "all not allowed with (implicit) nclass()"
	exit 198
}
quietly {
	local vartyp: type `varlist' 
	if "`vartyp'"=="byte"|"`vartyp'"=="long" {
		local vartyp int
	}
	sum `varlist'
	local minval=r(min)
	tempvar pp cp x
	local ncutp 0
	gen byte `x'=1 `if' `in'
	replace `x'=2 if `x'==.
	if "`all'"=="" {
		local andx1 "& `x'==1"
	}
	else local andx1
	local a `varlist'
	local format: format `a'
	local p=index("`format'", ".")
	if `p'>0 {
		local dec=int(real(substr("`format'",`p'+1,1))) /*Default number of decimals*/
	}
	else local dec 0
	if "`centile'"!="" {
		* Compute cutpoints for specified centiles
		local cutpoint
		tokenize `centile'
		while "`1'"!=""  {
			centile `a' `if' `in', centile(`1')
			local cut=r(c_1)
			local cutpoint `cutpoint' `cut'
			macro shift 
		}
	}
	if "`cutpoint'"!="" {
		tokenize `cutpoint'
		local p=`1'-1
		local i 1
		local recode  
		local recode2  
		local lb  
		while "`1'"!=""  {
			local ++ncutp
			local recode `recode',`1'
	 		local recode2 `recode2' `1'=`i'
			if `i'==1 & `minval'<`1' {
				local lb `lb' `i'"<=`1'"
			}
			else if `i'==1 {
				local lb `lb' `i'"`1'"
			}
			else {
				if "`vartyp'"=="int" {
					local ++p
				}
				if length("`p'-`1'")<=8 {
					local lb `lb' `i'"`p'-`1'"
				}
				else if length("`1'")<=5 {
					local lb `lb' `i'"-<=`1'"
				}
				else if length("`1'")==6{
					local lb `lb' `i'"<=`1'"
				}
				else if length("`1'")>=7 {
					local lb `lb' `i'"<`1'"
				}
			}
			local ++i
			local p `1'
			macro shift
		}
		if `ncutp'>0 {
			local lb `lb' `i'">`p'"  
			local ++p
			local recode `recode',`p'
			local nclass = `ncutp'+1
			local recode2 `recode2' `p'=`i'
			local ++i
			if "`missing'"=="missing" {
				local lb `lb' `i'"?"
			}
			gen `cp'=. 
			local i 0
		 	local avail 1
			while `avail'>0 {
				local ++i
				capture label define class`i' `lb'
				local avail =_rc
			}
		 	local lb class`i'
		}
	}
 	local b `generate'
 	if "`b'"==""|"`b'"=="." {
 		local b="`a'"+"c`nclass'"
 		if "`replace'"=="" {
 			confirm new var `b'
 		}
 		else cap drop `b'
 	}
 	sum `a' `if' `in'
 	sort `x' `a'
	if "`cutpoint'"!="" {
 		replace `cp'=recode(`a' `recode') if `a'<. `andx1'
 		recode `cp' `recode2'
 		gen byte `b'=`cp'
 	}
 	else {
 		local nc=r(N)/`nclass'
 		gen byte `b'=1+int((_n-.01)/`nc') if `a'<. `andx1'
 	}
 	replace `b'=`b'[_n-1] if `a'==`a'[_n-1] & `a'<. `andx1'  /* add  tied 
 		observations equal to obs in previous class to previous 
 		 class	 */
	if "`missing'"=="missing" & index("`format'", "d")==0 {
		replace `b'=`nclass'+1 if `b'==. `andx1'
	}
	 	/* Definition of value label if not a date variable and no cutpoint() option */
 	if index("`format'", "d")==0 & "`cutpoint'"=="" {
		sum `a' if `b'==`nclass'-1
		local ltmax=length(string(int(r(max))))
		local ltmin=length(string(int(r(min))))
		local ltfit=`ltmax'+`ltmin'
		local j 1
		while `j'<=`nclass' {
 			sum `a' if `b'==`j'
	 		local min=r(min)
 			local max=r(max)
 			if `j'==1 {
				local lmax=length(string(int(`max')))
				if `lmax'>4 {
					local d2 0
				}
				else local d2=min(`dec',5-`lmax')
				fns2  v `max', w(6) d(`d2')
				local lv=length("$v")-1
				capture label drop `b'
				if `nclass'==2 &`lv'<=5 {
					local vallab label define `b' 1"<=$v"
				}
				else if `nclass'==2 &`lv'==6 {
					local vallab label define `b' 1"<$v"
				}
				else if `dec'<=0 &`ltfit'<=7 {
					local vallab label define `b' 1"  <=$v"
				}
				else if `lv'<=4 {
					local vallab label define `b' 1" <=$v"
				}
				else if `lv'==5 {
					local vallab label define `b' 1"<=$v"
				}
				else if `lv'==6 {
					local vallab label define `b' 1"<$v"
				}
				else if `lv'>=7 {
					local v=$v/10^`lv'
					fns2 v `v', w(4) d(2)
					local v <${v}E`lv'
					local vallab label define `b' 1"`v'"
				}
			}
			else if `j'<`nclass' {
				local lmax =length(string(int(`max')))
				if `dec'<=0 & `ltfit'<=7 {
					local lmin=length(string(int(`min')))
					if `lmin'>1 {
						local d1 0
					}
					else local d1=min(`dec',1)
					if `lmax'>2 {
						local d2 0
					}
					else local d2=min(`dec', 3-`lmax')
					fns2  v1 `min', w(3) d(`d1')
					fns2  v2 `max', w(4) d(`d2')
					local v12 ${v1}-${v2}
					local lv=length("$v1")-1
					if `lv'==0 {
						local vallab `vallab' `j'"  `v12'"
					}
					else if `lv'==1 {
						local vallab `vallab' `j'" `v12'"
					}
					else if `lv'>=2 {
						local vallab `vallab' `j'"`v12'"
					}
				}
				else {
					if `lmax'>4 {
						local d2 0
					}
					else local d2=min(`dec', 5-`lmax')
					fns2  v2 `max', w(6) d(`d2')
					local lv=length("$v2")-1
					if `lv'<=4 {
						local v12 -<=$v2
					}
					else if `lv'==5 {
						local v12 <=$v2
					}
					else if `lv'==6 {
						local v12 <$v2
					}
					else if `lv'>=7 { 
						local v2=$v2/10^`lv'
						fns2 v2 `v2',w(4) d(2)
						local v12 <${v2}E`lv' 
					}
					local vallab `vallab' `j'"`v12'"
				}
			}
	 		else  {
				local lmin =length(string(int(`min')))
				if  `lmin'>5 {
					local d2 0
				}
				else local d2 =min(`dec',6-`lmin')
				fns2  v `min', w(6) d(`d2')
				local lv=length("$v")-1
				if `dec'<=0 & `ltfit'<=7 & `lv'<=3 {
					local vallab `vallab' `j'"  >=$v"
				}
				else if `lv'<=4 {
					local vallab `vallab' `j'" >=$v"
				}
				else if `lv'==5 {
					local vallab `vallab' `j'">=$v"
				}
				else if `lv'==6 {
					local vallab `vallab' `j'">$v"
				}
				else if `lv'>=7 { 
					local v=$v/10^(`lv')
					fns2 v `v', w(4) d(2)
					local vallab `vallab' `j'">${v}E`lv'"
				}
			}
			local ++j
		}
		if "`missing'"=="missing" {
			local vallab `vallab' `j'"?"
		}
		`vallab'
		local lb `b'
	}
	else if "`cutpoint'"=="" {
		local lb .
	}
 	local lab: variable label `a'
 	if "`lab'"=="" {
 		local lab `a'
 	}
	change2 `b' . `lb' `nclass'-c `lab'
}
end

!* v 1.0.0 PR 30jul2004
program define fns2
/*
*fns.ado
*14/9/95   
*1/10/96 Adapted to strings containing elapsed dates
*WvP
 Formats a (string containing a) numeric value into a string 
 of specified width (length string, default 5)
 and specified number of decimals (default 0) 

Syntax: 

	fns new old, Width(int) Dec(int) DAte(string)

new 	the name of a global macro 
old 	a number, scalar, expression 
	or 
	a macro containing a number without blanks
string  contains a date format %d or %d...

*/
version 8
tokenize "`*'", parse(",")
local pre `1'
local opt `3'
gettoken new old: pre
if "`old'"=="" | "`old'"=="." {
	global `new' "." 
	exit
}

local 0 ,`opt'
syntax [, Width(int 5) Dec(int 0) Date(string) ]
local x `old'
local p=index("`x'", ".")
local l=length("`x'")

*First if not a date format specified:
if "`date'"=="" {
	*Reduce the number of decimals such that the total length fits -if possible-
	* in the specified width
	if `p'>0 {
		local dec=min(`dec', max(0,`width'-`p'))
	}
	else if `p'==0 {
		local dec=min(`dec', max(0,`width'-`l'-1))
	}

* local z=round(`old',10^-`dec')
* local p1= index("`z'",".") 

	if `p'>0 & `p'+`dec'<`l' {
		local x=`old' + sign(`old')*.499999*10^-`dec'
		local l=length("`x'")
		local p=index("`x'",".")
	}
	if `dec'>0 {
		local y "`x'"
		if `p'==0 {    /* Add . and zero's */
			local y="`x'"+"."
			local i 1
			while `i'<=`dec' {
				local y="`y'"+"0"
				local i=`i'+1
			}
		}
		else if `p'+`dec'>`l' & `width'>=`p'+`dec' {  /* Add zero's */
			local y "`x'"
			local i 1 
			while `i'<=`p'+`dec'-`l' {
				local y "`y'0"
				local i=`i'+1
			}
		}
		else if `p'+`dec'<=`l' {
			local y=substr("`x'",1,`p'+`dec') 
		}
	}  /* end if dec > 0 */
	else /* dec = 0, no decimals or decimal point */ local y=int(round(`old',1))
}
else /* date format specified */ local y: display `date' = `old'
global `new' "`y'"
end

program define change2
/*
*change.ado
*12/11/97 -> 3/5/99
*WvP
changes variable attributes

change varname [newname|.  [label|.    varlab] ]

1. varname existing variable
2. newname new name (should not exist) or . if the same name
3. label   name of value label
4. varlab  variable label

1,2 and 3 without embedded blanks.

Example:

 change var1 boter . . Boter is beter

hernoemt var1 in boter met variable label  "Boter is beter"

3/5/99: odd blanks are allowed now in variable label part! 
*/
version 8
quietly {
	local total `0'
	local l1=length("`1'")+1
	local l2=length("`2'")+1
	local l3=length("`3'")+1
	unab var: `1'
	if "`2'"!="." & "`2'"!="-" & "`2'"!="" {
		rename `var' `2'
		local var `2'
	}
	if "`3'"=="-" {
		label values `var'
	}
	else if "`3'"!="." & "`3'"!="" & "`3'"!="" {
		label values `var' `3'
	}
	macro shift 3
	local varlab "`*'"
	if "`varlab'"!="" & "`varlab'"!="." & "`varlab'"!="-" {
		local total=trim(substr("`total'",`l1',.))	     
		local total=trim(substr("`total'",`l2',.))	     
		local varlab=trim(substr("`total'",`l3',.))
		label variable `var' "`varlab'"
	}
	else if "`varlab'"=="-" {
		label variable `var'
	}
}   
end
