program define fpcurv, rclass
syntax varlist(min=2 max=2), Cmd(string) [ COVars(string) Degree(int 2) MONo * ]
tokenize `varlist'
local y `1'
local x `2'
tokenize -2 -1 -0.5 0 0.5 1 2 3
local i 1
while "``i''"!="" {
	local p`i' ``i''
	local i=`i'+1
}
local np=`i'-1
quietly {
	tempvar tmp d2 P1 P2 dev
	gen `d2'=.
	gen `P1'=.
	gen `P2'=.
	gen `dev'=.
	if "`mono'"!="" {	/* to determine if mono */
		tempvar xpk
		gen `xpk'=.
	}
	local devbest 1e30
	local i 0
	local j 1
	while `j'<=`np' {
		if `degree'==2 {
			local k `j'
			while `k'<=`np' {
				fracpoly `cmd' `y' `x' `p`j'' `p`k'' `covars', `options'
				local i=`i'+1
				replace `P1'=`p`j'' in `i'
				replace `P2'=`p`k'' in `i'
				replace `dev'=e(fp_dev) in `i'
				if "`mono'"!="" {
					fractp
					replace `xpk'=r(xpk) in `i'
				}
				fracdydx, d(2) gen(`tmp')
				replace `tmp'=abs(`tmp')
				sum `tmp',meanonly
				replace `d2'=r(mean) in `i'
				drop `tmp'
				if `dev'[`i']<`devbest' {
					local devbest=`dev'[`i']
					local power `p`j'' `p`k''
				}
				local k=`k'+1
			}
		}
		else {
			fracpoly `cmd' `y' `x' `p`j'' `covars', `options'
			local i=`i'+1
			replace `P1'=`p`j'' in `i'
			replace `dev'=e(fp_dev) in `i'
			fracdydx, d(2) gen(`tmp')
			replace `tmp'=abs(`tmp')
			sum `tmp', meanonly
			replace `d2'=r(mean) in `i'
			drop `tmp'
			if `dev'[`i']<`devbest' {
				local devbest=`dev'[`i']
				local power `p`j''
			}
			local k=`k'+1
		}
		local j=`j'+1
	}
	cap drop _p1
	cap drop _p2
	cap drop _dev
	cap drop _d2
	rename `P1' _p1	
	rename `P2' _p2
	rename `dev' _dev
	rename `d2' _d2
	if "`mono'"!="" {
		cap drop _xpk
		rename `xpk' _xpk
	}
}
di _n in gr "Powers = " in ye "`power'" in gr " deviance = " in ye `devbest'
ret local power `power'
ret local devbest `devbest'
end

*! version 1.0.0 PR 09Jun1999.
program define fractp, rclass
* Determines peak/nadir for m=2 curve, if it exists. Based on _jprfptp.ado.
	version 6
	if "`e(cmd)'" == "" | "`e(fp_cmd2)'" != "fracpoly" {
		error 301
	}
	local np: word count `e(fp_xp)'
	if `np'!=2 {
		di in red "degree 2 fractional polynomial required"
		exit 198
	}
	tempname p1 p2 b1 b2 gamma small gp1 gp2 xpk scale shift expx
	local w: word 1 of `e(fp_k1)'
	scalar `p1'=`w'
	local w: word 2 of `e(fp_k1)'
	scalar `p2'=`w'
	local w: word 1 of `e(fp_xp)'
	scalar `b1'=_b[`w']
	local w: word 2 of `e(fp_xp)'
	scalar `b2'=_b[`w']
	scalar `scale'=e(fp_sfac)
	scalar `shift'=e(fp_shft)
	if "`e(fp_xpx)'"!="" {
		scalar `expx'=`e(fp_xpx)'
	}
	else scalar `expx'=0
	scalar `small'=1e-6

	scalar `gamma'=`b2'/`b1'
	scalar `gp1'=`gamma'/`p1'
	scalar `gp2'=`gamma'*`p2'
	scalar `xpk'=.
	if abs(`p1')<`small' {
		if abs(`p2')<`small' { 		/* (0,0) */
			scalar `xpk'=-1/(2*`gamma')
		}
		else {				/* (0,p2) */
			if `gp2'<0 { scalar `xpk'=-log(-`gp2')/`p2' }
		}
	}
	else if abs(`p2')<`small' {		/* (p1,0) */
		if `gp1'<0 { scalar `xpk'=log(-`gp1')/`p1' }
	}
	else {
		if abs(`p2'-`p1')<`small' {	/* (p1,p1) */
			scalar `xpk'=-1/`p1'-1/`gamma'
		}
		else {				/* (p1,p2) */
			if `p2'*`gp1'<0 {
				scalar `xpk'=log(-`p2'*`gp1')/(`p1'-`p2')
			}
		}
	}
/*
	Code from _jprfpmm
*/
	local X `e(fp_x1)'
	tempname x y1 y2 temp ypk
	scalar `x'=`xpk'
	fpcalc `x' `p1' `p2' `gamma' `small'
	scalar `y1'=`b1'*r(fpcal)
	scalar `x'=`x'+0.1
	fpcalc `x' `p1' `p2' `gamma' `small'
	scalar `y2'=`b1'*r(fpcal)
	di in gr _n "Curve (" in ye `p1' in gr "," /*
	 */ in ye `p2' in gr ") " _cont
	if `xpk'!=. {
		if `y2'<`y1' {
			local pkt "maximum"
		}
		else 	local pkt "minimum"
		if `expx'!=0 {
			scalar `xpk'=`xpk'/`expx'
		}
		else 	scalar `xpk'=exp(`xpk')
		scalar `xpk'=`xpk'*`scale'-`shift'
		qui fraceval num `xpk'
		scalar `ypk'=r(fp)
		di in gr "has a global `pkt' of " in ye %9.0g `ypk' /*
		 */ in gr " at `X' = " in ye %8.0g `xpk' in gr "."
	}
	else {
		scalar `ypk'=.
		if `expx'<0 {
			scalar `temp'=`y1'
			scalar `y1'=`y2'
			scalar `y2'=`temp'
		}
		if `y2'>`y1' { local pkt "positive" }
		else local pkt "negative"
		di in gr "has a `pkt' slope and" /*
		 */ " no maximum or minimum for `X'>0."
	}
	return scalar xpk=`xpk'
	return scalar ypk=`ypk'
	return local pkt `pkt'
end

program define fpcalc, rclass
	args x p1 p2 gamma small
	tempname fpcal
	if abs(`p1')<`small' {
		if abs(`p2')<`small' { 		/* (0,0) */
			scalar `fpcal'=`x'*(1+`gamma'*`x')
		}
		else {				/* (0,p2) */
			scalar `fpcal'=`x'+`gamma'*exp(`p2'*`x')
		}
	}
	else if abs(`p2')<`small' {		/* (p1,0) */
		scalar `fpcal'=`gamma'*`x'+exp(`p1'*`x')
	}
	else {
		if abs(`p2'-`p1')<`small' {	/* (p1,p1) */
			scalar `fpcal'=exp(`p1'*`x')*(1+`gamma'*`x')
		}
		else {				/* (p1,p2) */
			scalar `fpcal'=exp(`p1'*`x')+`gamma'*exp(`p2'*`x')
		}
	}
	return scalar fpcal=`fpcal'
end
