*! v 1.0.1 PR 08nov2007
program define icc, rclass sortpreserve
/*
	Intra-class correlation coefficient for 2 continuous variables.
	See Dunn (1989) Design & analysis of reliability studies, Edward Arnold, London, p 34.
*/
version 8.2
syntax varlist(min=2 max=2 numeric) [if] [in] [, Rank ]
quietly {
	marksample touse
	* Reverse X and Y, double data and correlate
	preserve
	gettoken x y : varlist
	keep if `touse'
	keep `x' `y' `touse'
	local n = _N
	if "`rank'"!="" {
		cap drop _rx
		cap drop _ry
		egen _rx = rank(`x') if `touse'
		egen _ry = rank(`y') if `touse'
		local x _rx
		local y _ry
	}
	expand 2
	local ty: type `y'
	tempvar z
	gen `ty' `z' = `y' if _n>`n'
	replace `y' = `x' if _n>`n'
	replace `x' = `z' if _n>`n'
	correlate `x' `y'
}
return scalar icc = r(rho)
noi di as txt "Intraclass `rank' correlation (" as res `n' as txt " pairs) = " %6.4f as res return(icc)
end
