*! version 1.0.0 PR 22feb2007
program define mfpintall, rclass
version 8
gettoken cmd 0: 0
frac_chk `cmd' 
if `s(bad)' { 
	di as err "invalid or unrecognised command, `cmd'"
	exit 198
}
local dist `s(dist)'
local normal = (`dist'==0)
global MFpdist `dist'

// Disentangle
GetVL `0'
local 0 `s(nought)'

syntax [if] [in] [aw fw pw iw] , ///
 [ COVars(string) ALpha(real .05) DEAD(varname) MFPopts(string) SELect(string) * ]

if "`select'"=="" local select 1
else if "`select'"=="no" local select -1
else confirm num `select'
quietly {
	marksample touse
	markout `touse' $MFP_cur `covars' `dead'
	frac_wgt "`exp'" `touse' "`weight'"
	local wgt `r(wgt)'	// [`weight'`exp']
	if "`dead'"!="" local options "`options' dead(`dead')"

	local nx $MFP_n	/* number of clusters, <= number of predictors */
	local yvar $MFP_dv
	local xvars
	forvalues a = 1/`nx' {
		local mfp`a' ${MFP_`a'}
		local xvars `xvars' `mfp`a''
	}

	// Consider all pairs of variables
	local nx1 = `nx'-1
	forvalues a = 1/`nx1' {
		local v1 `mfp`a''
		local a1 = `a'+1
		forvalues b = `a1'/`nx' {
			local v2 `mfp`b''
			local vw `v1' `v2'
			if `select' > -1 {
				local vars: list xvars - vw
				mfp `cmd' `yvar' (`v1') (`v2') `vars' `covars' if `touse' `wgt', ///
				 select(`select', (`v1') (`v2'):1) alpha(`alpha') `dead' `mfpopts' `options'
			}
			else {
				mfp `cmd' `yvar' (`v1') (`v2') `covars' if `touse' `wgt', ///
				 select(1) alpha(`alpha') `dead' `mfpopts' `options'
			}
			// Get info on selected model for v1 and v2
			local dev0 = e(fp_dev)
			local model `e(fp_fvl)'
			local nobs = e(N)
			local df_r = e(df_r)	// does not allow for FP df.
			forvalues j=1/2 {
				local p`j' `e(fp_k`j')'
				if "`p`j''"!="1" {
					local np`j': word count `p`j''
					qui fracgen `v`j'' `p`j'', replace
					local n`j' `r(names)'
				}
				else {
					local np`j': word count `v`j''	// could consist of several vars
					local n`j' `v`j''
				}
			}
			local xy	// macro to hold names of interaction variable(s)
			forvalues i=1/`np1' {
				local xa: word `i' of `n1'
				forvalues j=1/`np2' {
					local xb: word `j' of `n2'
					cap drop _xy`i'`j'
					gen _xy`i'`j'=`xa'*`xb'
					local xy `xy' _xy`i'`j'
				}
			}
			`cmd' `yvar' `model' `xy' if `touse' `wgt', `dead' `options'
			local df: word count `xy'
			local dev1 = -2*e(ll)
			local d = `dev0'-`dev1'
			noi di as txt _n "{hline 79}" _n "v1 = `v1' (`p1'), v2 = `v2' (`p2')" _n
			frac_pv `normal' "`wgt'" `nobs' `d' `df' `df_r'
			noi di as txt "dev diff = " as res %9.4f `d' ///
			 as txt " df = " as res `df' as txt" P = " as res %7.5f r(P)
			drop `xy'
		}
	}
}
end

program define GetVL, sclass /* varlist [if|in|,|[weight]] */
version 8
macro drop MFP_*
if $MFpdist != 7 {
	gettoken tok 0 : 0
	unabbrev `tok'
	global MFP_dv "`s(varlist)'"
}

global MFP_cur		/* MFP_cur will contain full term list */
global MFP_n 0

gettoken tok : 0, parse(" ,[")
IfEndTrm "`tok'"
while `s(IsEndTrm)'==0 {
	gettoken tok 0 : 0, parse(" ,[")
	if substr("`tok'",1,1)=="(" {
		local list
		while substr("`tok'",-1,1)!=")" {
			if "`tok'"=="" {
				di in red "varlist invalid"
				exit 198
			}
			local list "`list' `tok'"
			gettoken tok 0 : 0, parse(" ,[")
		}
		local list "`list' `tok'"
		unabbrev `list'
		global MFP_n = $MFP_n + 1
		global MFP_$MFP_n "`s(varlist)'"
		global MFP_cur "$MFP_cur `s(varlist)'"
	}
	else {
		unabbrev `tok'
		local i 1
		local w : word 1 of `s(varlist)'
		while "`w'" != "" {
			global MFP_n = $MFP_n + 1
			global MFP_$MFP_n "`w'"
			local i = `i' + 1
			local w : word `i' of `s(varlist)'
		}
		global MFP_cur "$MFP_cur `s(varlist)'"
	}
	gettoken tok : 0, parse(" ,[")
	IfEndTrm "`tok'"
}
sret local nought `0'
end

program define IfEndTrm, sclass
version 8
sret local IsEndTrm 1
if "`1'"=="," | "`1'"=="in" | "`1'"=="if" | /*
*/ "`1'"=="" | "`1'"=="[" {
	exit
}
sret local IsEndTrm 0
end
